Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1185002 - Review Request: appmenu-qt5 - Support for global DBus-exported application menu in Qt5
Summary: Review Request: appmenu-qt5 - Support for global DBus-exported application me...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: MartinKG
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: qt-reviews
TreeView+ depends on / blocked
 
Reported: 2015-01-22 16:52 UTC by Mario Blättermann
Modified: 2016-10-07 19:09 UTC (History)
5 users (show)

Fixed In Version: appmenu-qt5-0.r26-3.fc21
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-02-28 10:24:57 UTC
mgansser: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Mario Blättermann 2015-01-22 16:52:57 UTC
Spec URL: https://mariobl.fedorapeople.org/Review/SPECS/appmenu-qt5.spec
SRPM URL: https://mariobl.fedorapeople.org/Review/SRPMS/appmenu-qt5-0.3.0-r26.1.fc21.src.rpm

Description:
This is a different, Qt5-compatible approach of the existing appmenu-qt
(https://launchpad.net/appmenu-qt).

appmenu-qt5 is a Qt5 QPA theme plugin that adds support for application
menus to Qt5 applications. This only works for Qt5 versions >= 5.2
currently. To enable the support, set QT_QPA_PLATFORMTHEME=appmenu-qt5
in your environment.

Fedora Account System Username: mariobl


I get this from rpmlint:

appmenu-qt5.spec:40: W: rpm-buildroot-usage %build make %{?_smp_mflags} INSTALL_ROOT=$RPM_BUILD_ROOT
$RPM_BUILD_ROOT should not be touched during %build or %prep stage, as it may
break short circuit builds.

But I don't know another solution to make the install directory known to qmake-qt5.

Moreover, I'm not sure about versioning. Ubuntu uses the same generated tarball for the package version 0.3.0 although I can't find that number anywhere in the source files. As far as I can evaluate, they use it only for distinction between the existing Qt4 version and the Qt5 package.

Comment 1 Mario Blättermann 2015-01-22 17:06:26 UTC
Some hint about the script in %{_sysconfdir}/profile.d/: This script activates the Qt module globally. Actually it does the same as described in README. But this is eventually not desired for systems with multiple users. It could happen that the menu bar of Qt5 applications doesn't appear on desktops without plasma-widget-menubar. Maybe it would be better to drop CONFIG+=enable-by-default from the spec file to disable installing the script...?

Comment 2 Rex Dieter 2015-01-22 17:45:08 UTC
Good point, for now I think it safer to provide a sample script as %doc and include a README.fedora to document how a user could include it in their environment.

Once appmenu-qt5 has formal releases and/or it is better tested, then enabling by default would be ok.

Comment 3 Mario Blättermann 2015-01-22 19:14:31 UTC
(In reply to Rex Dieter from comment #2)
> Good point, for now I think it safer to provide a sample script as %doc and
> include a README.fedora to document how a user could include it in their
> environment.
> 
OK, I will do that. The appropriate config option in KDE 4 doesn't affect the behavior of Qt5 apps, I was wondering if it would work in KDE Frameworks 5?

> Once appmenu-qt5 has formal releases and/or it is better tested, then
> enabling by default would be ok.

I would it never enable by default. Imagine, it is the default on a multiuser system. This is only OK if all users work with Plasma (currently v4 only) and have plasma-widget-menubar enabled. In all other cases Qt5 apps remain without menubar, because the module will be loaded at system startup. Correct me if I'm wrong.

Comment 4 Mario Blättermann 2015-01-25 16:51:52 UTC
New files:

Spec URL: https://mariobl.fedorapeople.org/Review/SPECS/appmenu-qt5.spec
SRPM URL: https://mariobl.fedorapeople.org/Review/SRPMS/appmenu-qt5-0.r26-1.fc21.src.rpm

- Dropped non-existent version number
- Use the script as example, move it to %%doc
- Add README.fedora

Comment 5 MartinKG 2015-02-16 16:02:08 UTC
2 issues, please fix this:


1. Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see attached
     diff).
     See: (this test has no URL)

2. Rpmlint
-------
Checking: appmenu-qt5-0.r26-1.fc22.x86_64.rpm
          appmenu-qt5-0.r26-1.fc22.src.rpm
appmenu-qt5.x86_64: W: incoherent-version-in-changelog 0.3.0-r26.1.1 ['0.r26-1.fc22', '0.r26-1']
appmenu-qt5.src: W: invalid-url Source0: appmenu-qt5-0.r26.tar.gz
2 packages and 0 specfiles checked; 0 errors, 2 warnings.


Diff spec file in url and in SRPM
---------------------------------
--- /home/martin/rpmbuild/SPECS/1185002-appmenu-qt5/srpm/appmenu-qt5.spec       2015-02-16 16:52:27.250031296 +0100
+++ /home/martin/rpmbuild/SPECS/1185002-appmenu-qt5/srpm-unpacked/appmenu-qt5.spec      2015-01-25 17:35:02.000000000 +0100
@@ -58,8 +58,6 @@

 %changelog
-* Sun Jan 25 2015 Mario Blättermann <mario.blaettermann@gmail.com> - 0.r26-1
-- Dropped non-existent version number
-- Use the script as example, move it to %%doc
-- Add README.fedora
+* Sun Jan 25 2015 Mario Blättermann <mario.blaettermann@gmail.com> - 0.3.0-r26.1.1
+- rebuilt

 * Wed Dec 17 2014 Mario Blättermann <mario.blaettermann@gmail.com> 0.3.0-r26.1

Comment 6 MartinKG 2015-02-16 19:28:10 UTC
Taking this for a full review.

Comment 7 Mario Blättermann 2015-02-17 14:03:19 UTC
New files:

Spec URL: https://mariobl.fedorapeople.org/Review/SPECS/appmenu-qt5.spec
SRPM URL:https://mariobl.fedorapeople.org/Review/SRPMS/appmenu-qt5-0.r26-3.fc21.src.rpm

The .cmake file is now in a -devel subpackage. I've untangled the versioning in %changelog, because I don't want to copy Ubuntu's versioning anyway.

Comment 8 MartinKG 2015-02-17 14:47:08 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- If (and only if) the source package includes the text of the license(s) in
  its own file, then that file, containing the text of the license(s) for the
  package is included in %doc.
  Note: Cannot find COPYING in rpm(s)
  See:
  http://fedoraproject.org/wiki/Packaging/LicensingGuidelines#License_Text


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated", "LGPL (v3)". 1 files have unknown license.
     Detailed output of licensecheck in /home/martin/rpmbuild/SPECS/1185002
     -appmenu-qt5/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib64/cmake,
     /usr/lib64/cmake/Qt5Gui
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[-]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[-]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
     Note: Test run failed
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Test run failed
[x]: Packages must not store files under /srv, /opt or /usr/local
     Note: Test run failed
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[-]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
     Note: Test run failed
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: appmenu-qt5-0.r26-3.fc22.x86_64.rpm
          appmenu-qt5-devel-0.r26-3.fc22.x86_64.rpm
          appmenu-qt5-0.r26-3.fc22.src.rpm
appmenu-qt5-devel.x86_64: W: only-non-binary-in-usr-lib
appmenu-qt5-devel.x86_64: W: no-documentation
appmenu-qt5.src: W: invalid-url Source0: appmenu-qt5-0.r26.tar.gz
3 packages and 0 specfiles checked; 0 errors, 3 warnings.




Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Requires
--------
appmenu-qt5 (rpmlib, GLIBC filtered):
    libEGL.so.1()(64bit)
    libGL.so.1()(64bit)
    libQt5Core.so.5()(64bit)
    libQt5DBus.so.5()(64bit)
    libQt5Gui.so.5()(64bit)
    libQt5Widgets.so.5()(64bit)
    libX11.so.6()(64bit)
    libXext.so.6()(64bit)
    libXrender.so.1()(64bit)
    libatk-1.0.so.0()(64bit)
    libc.so.6()(64bit)
    libcairo.so.2()(64bit)
    libdbusmenu-qt5.so.2()(64bit)
    libfontconfig.so.1()(64bit)
    libfreetype.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libgdk-x11-2.0.so.0()(64bit)
    libgdk_pixbuf-2.0.so.0()(64bit)
    libgio-2.0.so.0()(64bit)
    libglib-2.0.so.0()(64bit)
    libgobject-2.0.so.0()(64bit)
    libgthread-2.0.so.0()(64bit)
    libgtk-x11-2.0.so.0()(64bit)
    libm.so.6()(64bit)
    libpango-1.0.so.0()(64bit)
    libpangocairo-1.0.so.0()(64bit)
    libpangoft2-1.0.so.0()(64bit)
    libpthread.so.0()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libudev.so.1()(64bit)
    qt5-qtbase-gui
    rtld(GNU_HASH)

appmenu-qt5-devel (rpmlib, GLIBC filtered):
    appmenu-qt5(x86-64)



Provides
--------
appmenu-qt5:
    appmenu-qt5
    appmenu-qt5(x86-64)
    libappmenu-qt5.so()(64bit)

appmenu-qt5-devel:
    appmenu-qt5-devel
    appmenu-qt5-devel(x86-64)



Unversioned so-files
--------------------
appmenu-qt5: /usr/lib64/qt5/plugins/platformthemes/libappmenu-qt5.so

Generated by fedora-review 0.5.2 (63c24cb) last change: 2014-07-14
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 1185002
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Package APPROVED

Comment 9 Mario Blättermann 2015-02-17 19:43:03 UTC
Many thanks for the review and approval!

New Package SCM Request
=======================
Package Name: appmenu-qt5
Short Description: Support for global DBus-exported application menu in Qt5
Upstream URL: https://launchpad.net/appmenu-qt5
Owners: mariobl
Branches: f21 f22

Comment 10 Gwyn Ciesla 2015-02-17 20:30:00 UTC
Git done (by process-git-requests).

Comment 11 Fedora Update System 2015-02-17 21:15:56 UTC
appmenu-qt5-0.r26-3.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/appmenu-qt5-0.r26-3.fc21

Comment 12 Fedora Update System 2015-02-19 02:57:54 UTC
Package appmenu-qt5-0.r26-3.fc21:
* should fix your issue,
* was pushed to the Fedora 21 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing appmenu-qt5-0.r26-3.fc21'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2015-2248/appmenu-qt5-0.r26-3.fc21
then log in and leave karma (feedback).

Comment 13 Fedora Update System 2015-02-28 10:24:57 UTC
appmenu-qt5-0.r26-3.fc21 has been pushed to the Fedora 21 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.